// Implementation file for parser generated by fsyacc
#light
#nowarn "64";; // turn off warnings that type variables used in production annotations are instantiated to concrete type
open Microsoft.FSharp.Text.Lexing
open Microsoft.FSharp.Text.Parsing.ParseHelpers
# 1 "pars.fsy"


open Ast


# 12 "pars.fs"
// This type is the type of tokens accepted by the parser
type token = 
  | RPAREN
  | LPAREN
  | COMMA
  | EQUALS
  | ASSIGNS
  | IMPLIES
  | PERIOD
  | TILDE
  | QUERY
  | EOF
  | INCLUDE
  | LANGLE
  | RANGLE
  | PLUS
  | MINUS
  | SEMI
  | INT of (int)
  | STRING of (string)
  | FILENAME of (string)
  | VARSYM of (string)
  | SYMBOL of (string)
// This type is used to give symbolic names to token indexes, useful for error messages
type tokenId = 
    | TOKEN_RPAREN
    | TOKEN_LPAREN
    | TOKEN_COMMA
    | TOKEN_EQUALS
    | TOKEN_ASSIGNS
    | TOKEN_IMPLIES
    | TOKEN_PERIOD
    | TOKEN_TILDE
    | TOKEN_QUERY
    | TOKEN_EOF
    | TOKEN_INCLUDE
    | TOKEN_LANGLE
    | TOKEN_RANGLE
    | TOKEN_PLUS
    | TOKEN_MINUS
    | TOKEN_SEMI
    | TOKEN_INT
    | TOKEN_STRING
    | TOKEN_FILENAME
    | TOKEN_VARSYM
    | TOKEN_SYMBOL
    | TOKEN_end_of_input
    | TOKEN_error
// This type is used to give symbolic names to token indexes, useful for error messages
type nonTerminalId = 
    | NONTERM__startstart
    | NONTERM_start
    | NONTERM_Prog
    | NONTERM_PreProcess
    | NONTERM_ParseProgBody
    | NONTERM_ParseClauseList
    | NONTERM_ParseClause
    | NONTERM_ParseLitList
    | NONTERM_ParseLiteral
    | NONTERM_Literal
    | NONTERM_FilterList
    | NONTERM_Filter
    | NONTERM_FnList
    | NONTERM_Function
    | NONTERM_TermList
    | NONTERM_NETermList
    | NONTERM_Expression
    | NONTERM_VarTerm
    | NONTERM_Term
    | NONTERM_Predicate

// This function maps tokens to integers indexes
let tagOfToken (t:token) = 
  match t with
  | RPAREN  -> 0 
  | LPAREN  -> 1 
  | COMMA  -> 2 
  | EQUALS  -> 3 
  | ASSIGNS  -> 4 
  | IMPLIES  -> 5 
  | PERIOD  -> 6 
  | TILDE  -> 7 
  | QUERY  -> 8 
  | EOF  -> 9 
  | INCLUDE  -> 10 
  | LANGLE  -> 11 
  | RANGLE  -> 12 
  | PLUS  -> 13 
  | MINUS  -> 14 
  | SEMI  -> 15 
  | INT _ -> 16 
  | STRING _ -> 17 
  | FILENAME _ -> 18 
  | VARSYM _ -> 19 
  | SYMBOL _ -> 20 

// This function maps integers indexes to symbolic token ids
let tokenTagToTokenId (tokenIdx:int) = 
  match tokenIdx with
  | 0 -> TOKEN_RPAREN 
  | 1 -> TOKEN_LPAREN 
  | 2 -> TOKEN_COMMA 
  | 3 -> TOKEN_EQUALS 
  | 4 -> TOKEN_ASSIGNS 
  | 5 -> TOKEN_IMPLIES 
  | 6 -> TOKEN_PERIOD 
  | 7 -> TOKEN_TILDE 
  | 8 -> TOKEN_QUERY 
  | 9 -> TOKEN_EOF 
  | 10 -> TOKEN_INCLUDE 
  | 11 -> TOKEN_LANGLE 
  | 12 -> TOKEN_RANGLE 
  | 13 -> TOKEN_PLUS 
  | 14 -> TOKEN_MINUS 
  | 15 -> TOKEN_SEMI 
  | 16 -> TOKEN_INT 
  | 17 -> TOKEN_STRING 
  | 18 -> TOKEN_FILENAME 
  | 19 -> TOKEN_VARSYM 
  | 20 -> TOKEN_SYMBOL 
  | 23 -> TOKEN_end_of_input
  | 21 -> TOKEN_error
  | _ -> failwith "tokenTagToTokenId: bad token"

/// This function maps production indexes returned in syntax errors to strings representing the non terminal that would be produced by that production
let prodIdxToNonTerminal (prodIdx:int) = 
  match prodIdx with
    | 0 -> NONTERM__startstart 
    | 1 -> NONTERM_start 
    | 2 -> NONTERM_Prog 
    | 3 -> NONTERM_PreProcess 
    | 4 -> NONTERM_PreProcess 
    | 5 -> NONTERM_ParseProgBody 
    | 6 -> NONTERM_ParseClauseList 
    | 7 -> NONTERM_ParseClauseList 
    | 8 -> NONTERM_ParseClause 
    | 9 -> NONTERM_ParseClause 
    | 10 -> NONTERM_ParseClause 
    | 11 -> NONTERM_ParseLitList 
    | 12 -> NONTERM_ParseLitList 
    | 13 -> NONTERM_ParseLiteral 
    | 14 -> NONTERM_ParseLiteral 
    | 15 -> NONTERM_ParseLiteral 
    | 16 -> NONTERM_ParseLiteral 
    | 17 -> NONTERM_Literal 
    | 18 -> NONTERM_FilterList 
    | 19 -> NONTERM_FilterList 
    | 20 -> NONTERM_Filter 
    | 21 -> NONTERM_Filter 
    | 22 -> NONTERM_Filter 
    | 23 -> NONTERM_Filter 
    | 24 -> NONTERM_FnList 
    | 25 -> NONTERM_FnList 
    | 26 -> NONTERM_Function 
    | 27 -> NONTERM_TermList 
    | 28 -> NONTERM_TermList 
    | 29 -> NONTERM_NETermList 
    | 30 -> NONTERM_NETermList 
    | 31 -> NONTERM_Expression 
    | 32 -> NONTERM_Expression 
    | 33 -> NONTERM_Expression 
    | 34 -> NONTERM_VarTerm 
    | 35 -> NONTERM_Term 
    | 36 -> NONTERM_Term 
    | 37 -> NONTERM_Term 
    | 38 -> NONTERM_Predicate 
    | _ -> failwith "prodIdxToNonTerminal: bad production index"

let _fsyacc_endOfInputTag = 23 
let _fsyacc_tagOfErrorTerminal = 21

// This function gets the name of a token as a string
let token_to_string (t:token) = 
  match t with 
  | RPAREN  -> "RPAREN" 
  | LPAREN  -> "LPAREN" 
  | COMMA  -> "COMMA" 
  | EQUALS  -> "EQUALS" 
  | ASSIGNS  -> "ASSIGNS" 
  | IMPLIES  -> "IMPLIES" 
  | PERIOD  -> "PERIOD" 
  | TILDE  -> "TILDE" 
  | QUERY  -> "QUERY" 
  | EOF  -> "EOF" 
  | INCLUDE  -> "INCLUDE" 
  | LANGLE  -> "LANGLE" 
  | RANGLE  -> "RANGLE" 
  | PLUS  -> "PLUS" 
  | MINUS  -> "MINUS" 
  | SEMI  -> "SEMI" 
  | INT _ -> "INT" 
  | STRING _ -> "STRING" 
  | FILENAME _ -> "FILENAME" 
  | VARSYM _ -> "VARSYM" 
  | SYMBOL _ -> "SYMBOL" 

// This function gets the data carried by a token as an object
let _fsyacc_dataOfToken (t:token) = 
  match t with 
  | RPAREN  -> (null : System.Object) 
  | LPAREN  -> (null : System.Object) 
  | COMMA  -> (null : System.Object) 
  | EQUALS  -> (null : System.Object) 
  | ASSIGNS  -> (null : System.Object) 
  | IMPLIES  -> (null : System.Object) 
  | PERIOD  -> (null : System.Object) 
  | TILDE  -> (null : System.Object) 
  | QUERY  -> (null : System.Object) 
  | EOF  -> (null : System.Object) 
  | INCLUDE  -> (null : System.Object) 
  | LANGLE  -> (null : System.Object) 
  | RANGLE  -> (null : System.Object) 
  | PLUS  -> (null : System.Object) 
  | MINUS  -> (null : System.Object) 
  | SEMI  -> (null : System.Object) 
  | INT _fsyacc_x -> Microsoft.FSharp.Core.Operators.box _fsyacc_x 
  | STRING _fsyacc_x -> Microsoft.FSharp.Core.Operators.box _fsyacc_x 
  | FILENAME _fsyacc_x -> Microsoft.FSharp.Core.Operators.box _fsyacc_x 
  | VARSYM _fsyacc_x -> Microsoft.FSharp.Core.Operators.box _fsyacc_x 
  | SYMBOL _fsyacc_x -> Microsoft.FSharp.Core.Operators.box _fsyacc_x 
let _fsyacc_gotos = [| 0us; 65535us; 1us; 65535us; 0us; 1us; 1us; 65535us; 0us; 2us; 2us; 65535us; 0us; 3us; 9us; 10us; 1us; 65535us; 3us; 4us; 2us; 65535us; 3us; 11us; 12us; 13us; 2us; 65535us; 3us; 12us; 12us; 12us; 2us; 65535us; 17us; 18us; 21us; 22us; 2us; 65535us; 17us; 20us; 21us; 20us; 2us; 65535us; 3us; 14us; 12us; 14us; 0us; 65535us; 2us; 65535us; 17us; 32us; 21us; 32us; 0us; 65535us; 2us; 65535us; 17us; 33us; 21us; 33us; 3us; 65535us; 24us; 25us; 29us; 30us; 35us; 36us; 4us; 65535us; 24us; 50us; 29us; 50us; 35us; 50us; 52us; 53us; 3us; 65535us; 48us; 49us; 57us; 55us; 58us; 56us; 2us; 65535us; 17us; 47us; 21us; 47us; 13us; 65535us; 17us; 38us; 21us; 38us; 24us; 51us; 29us; 51us; 35us; 51us; 39us; 40us; 41us; 42us; 43us; 44us; 45us; 46us; 48us; 54us; 52us; 51us; 57us; 54us; 58us; 54us; 5us; 65535us; 3us; 34us; 12us; 34us; 17us; 23us; 21us; 23us; 27us; 28us; |]
let _fsyacc_sparseGotoTableRowOffsets = [|0us; 1us; 3us; 5us; 8us; 10us; 13us; 16us; 19us; 22us; 25us; 26us; 29us; 30us; 33us; 37us; 42us; 46us; 49us; 63us; |]
let _fsyacc_stateToProdIdxsTableElements = [| 1us; 0us; 1us; 0us; 1us; 1us; 1us; 2us; 1us; 2us; 1us; 2us; 1us; 4us; 1us; 4us; 1us; 4us; 1us; 4us; 1us; 4us; 1us; 5us; 1us; 7us; 1us; 7us; 3us; 8us; 9us; 10us; 1us; 8us; 1us; 9us; 1us; 10us; 1us; 10us; 1us; 10us; 2us; 11us; 12us; 1us; 12us; 1us; 12us; 1us; 13us; 1us; 13us; 1us; 13us; 1us; 13us; 1us; 14us; 1us; 14us; 1us; 14us; 1us; 14us; 1us; 14us; 1us; 15us; 1us; 16us; 1us; 17us; 1us; 17us; 1us; 17us; 1us; 17us; 4us; 20us; 21us; 22us; 23us; 2us; 20us; 22us; 1us; 20us; 1us; 21us; 1us; 21us; 1us; 22us; 1us; 22us; 1us; 23us; 1us; 23us; 1us; 26us; 1us; 26us; 3us; 26us; 32us; 33us; 1us; 28us; 2us; 29us; 30us; 1us; 30us; 1us; 30us; 1us; 31us; 3us; 32us; 32us; 33us; 3us; 32us; 33us; 33us; 1us; 32us; 1us; 33us; 2us; 34us; 35us; 1us; 35us; 1us; 36us; 1us; 37us; 1us; 38us; |]
let _fsyacc_stateToProdIdxsTableRowOffsets = [|0us; 2us; 4us; 6us; 8us; 10us; 12us; 14us; 16us; 18us; 20us; 22us; 24us; 26us; 28us; 32us; 34us; 36us; 38us; 40us; 42us; 45us; 47us; 49us; 51us; 53us; 55us; 57us; 59us; 61us; 63us; 65us; 67us; 69us; 71us; 73us; 75us; 77us; 79us; 84us; 87us; 89us; 91us; 93us; 95us; 97us; 99us; 101us; 103us; 105us; 109us; 111us; 114us; 116us; 118us; 120us; 124us; 128us; 130us; 132us; 135us; 137us; 139us; 141us; |]
let _fsyacc_action_rows = 64
let _fsyacc_actionTableElements = [|1us; 16387us; 10us; 6us; 0us; 49152us; 0us; 16385us; 1us; 16390us; 20us; 63us; 1us; 32768us; 9us; 5us; 0us; 16386us; 1us; 32768us; 11us; 7us; 1us; 32768us; 18us; 8us; 1us; 32768us; 12us; 9us; 1us; 16387us; 10us; 6us; 0us; 16388us; 0us; 16389us; 1us; 16390us; 20us; 63us; 0us; 16391us; 3us; 32768us; 5us; 17us; 6us; 15us; 8us; 16us; 0us; 16392us; 0us; 16393us; 5us; 32768us; 7us; 27us; 16us; 61us; 17us; 62us; 19us; 59us; 20us; 63us; 1us; 32768us; 6us; 19us; 0us; 16394us; 1us; 16395us; 2us; 21us; 5us; 32768us; 7us; 27us; 16us; 61us; 17us; 62us; 19us; 59us; 20us; 63us; 0us; 16396us; 1us; 32768us; 1us; 24us; 3us; 16411us; 16us; 61us; 17us; 62us; 19us; 60us; 1us; 32768us; 0us; 26us; 0us; 16397us; 1us; 32768us; 20us; 63us; 1us; 32768us; 1us; 29us; 3us; 16411us; 16us; 61us; 17us; 62us; 19us; 60us; 1us; 32768us; 0us; 31us; 0us; 16398us; 0us; 16399us; 0us; 16400us; 1us; 32768us; 1us; 35us; 3us; 16411us; 16us; 61us; 17us; 62us; 19us; 60us; 1us; 32768us; 0us; 37us; 0us; 16401us; 3us; 32768us; 3us; 45us; 11us; 39us; 12us; 41us; 4us; 32768us; 3us; 43us; 16us; 61us; 17us; 62us; 19us; 60us; 0us; 16404us; 3us; 32768us; 16us; 61us; 17us; 62us; 19us; 60us; 0us; 16405us; 3us; 32768us; 16us; 61us; 17us; 62us; 19us; 60us; 0us; 16406us; 3us; 32768us; 16us; 61us; 17us; 62us; 19us; 60us; 0us; 16407us; 1us; 32768us; 4us; 48us; 3us; 32768us; 16us; 61us; 17us; 62us; 19us; 60us; 2us; 16410us; 13us; 57us; 14us; 58us; 0us; 16412us; 1us; 16413us; 2us; 52us; 3us; 32768us; 16us; 61us; 17us; 62us; 19us; 60us; 0us; 16414us; 0us; 16415us; 0us; 16416us; 0us; 16417us; 3us; 32768us; 16us; 61us; 17us; 62us; 19us; 60us; 3us; 32768us; 16us; 61us; 17us; 62us; 19us; 60us; 3us; 16418us; 3us; 16419us; 11us; 16419us; 12us; 16419us; 0us; 16419us; 0us; 16420us; 0us; 16421us; 0us; 16422us; |]
let _fsyacc_actionTableRowOffsets = [|0us; 2us; 3us; 4us; 6us; 8us; 9us; 11us; 13us; 15us; 17us; 18us; 19us; 21us; 22us; 26us; 27us; 28us; 34us; 36us; 37us; 39us; 45us; 46us; 48us; 52us; 54us; 55us; 57us; 59us; 63us; 65us; 66us; 67us; 68us; 70us; 74us; 76us; 77us; 81us; 86us; 87us; 91us; 92us; 96us; 97us; 101us; 102us; 104us; 108us; 111us; 112us; 114us; 118us; 119us; 120us; 121us; 122us; 126us; 130us; 134us; 135us; 136us; 137us; |]
let _fsyacc_reductionSymbolCounts = [|1us; 1us; 3us; 0us; 5us; 1us; 0us; 2us; 2us; 2us; 4us; 1us; 3us; 4us; 5us; 1us; 1us; 4us; 1us; 3us; 3us; 3us; 4us; 3us; 1us; 3us; 3us; 0us; 1us; 1us; 3us; 1us; 3us; 3us; 1us; 1us; 1us; 1us; 1us; |]
let _fsyacc_productionToNonTerminalTable = [|0us; 1us; 2us; 3us; 3us; 4us; 5us; 5us; 6us; 6us; 6us; 7us; 7us; 8us; 8us; 8us; 8us; 9us; 10us; 10us; 11us; 11us; 11us; 11us; 12us; 12us; 13us; 14us; 14us; 15us; 15us; 16us; 16us; 16us; 17us; 18us; 18us; 18us; 19us; |]
let _fsyacc_immediateActions = [|65535us; 49152us; 16385us; 65535us; 65535us; 16386us; 65535us; 65535us; 65535us; 65535us; 16388us; 16389us; 65535us; 16391us; 65535us; 16392us; 16393us; 65535us; 65535us; 16394us; 65535us; 65535us; 16396us; 65535us; 65535us; 65535us; 16397us; 65535us; 65535us; 65535us; 65535us; 16398us; 16399us; 16400us; 65535us; 65535us; 65535us; 16401us; 65535us; 65535us; 16404us; 65535us; 16405us; 65535us; 16406us; 65535us; 16407us; 65535us; 65535us; 65535us; 16412us; 65535us; 65535us; 16414us; 16415us; 65535us; 65535us; 65535us; 65535us; 65535us; 16419us; 16420us; 16421us; 16422us; |]
let _fsyacc_reductions ()  =    [| 
# 244 "pars.fs"
        (fun (parseState : Microsoft.FSharp.Text.Parsing.IParseState) ->
            let _1 = (let data = parseState.GetInput(1) in (Microsoft.FSharp.Core.Operators.unbox data :  Ast.Prog )) in
            Microsoft.FSharp.Core.Operators.box
                (
                   (
                      raise (Microsoft.FSharp.Text.Parsing.Accept(Microsoft.FSharp.Core.Operators.box _1))
                   )
                 : '_startstart));
# 253 "pars.fs"
        (fun (parseState : Microsoft.FSharp.Text.Parsing.IParseState) ->
            let _1 = (let data = parseState.GetInput(1) in (Microsoft.FSharp.Core.Operators.unbox data : 'Prog)) in
            Microsoft.FSharp.Core.Operators.box
                (
                   (
# 20 "pars.fsy"
                      _1 
                   )
# 20 "pars.fsy"
                 :  Ast.Prog ));
# 264 "pars.fs"
        (fun (parseState : Microsoft.FSharp.Text.Parsing.IParseState) ->
            let _1 = (let data = parseState.GetInput(1) in (Microsoft.FSharp.Core.Operators.unbox data : 'PreProcess)) in
            let _2 = (let data = parseState.GetInput(2) in (Microsoft.FSharp.Core.Operators.unbox data : 'ParseProgBody)) in
            Microsoft.FSharp.Core.Operators.box
                (
                   (
# 22 "pars.fsy"
                      Program(Preprocess(_1), Parseprogbody(_2)) 
                   )
# 22 "pars.fsy"
                 : 'Prog));
# 276 "pars.fs"
        (fun (parseState : Microsoft.FSharp.Text.Parsing.IParseState) ->
            Microsoft.FSharp.Core.Operators.box
                (
                   (
# 24 "pars.fsy"
                      [] 
                   )
# 24 "pars.fsy"
                 : 'PreProcess));
# 286 "pars.fs"
        (fun (parseState : Microsoft.FSharp.Text.Parsing.IParseState) ->
            let _3 = (let data = parseState.GetInput(3) in (Microsoft.FSharp.Core.Operators.unbox data : string)) in
            let _5 = (let data = parseState.GetInput(5) in (Microsoft.FSharp.Core.Operators.unbox data : 'PreProcess)) in
            Microsoft.FSharp.Core.Operators.box
                (
                   (
# 25 "pars.fsy"
                      _3 :: _5 
                   )
# 25 "pars.fsy"
                 : 'PreProcess));
# 298 "pars.fs"
        (fun (parseState : Microsoft.FSharp.Text.Parsing.IParseState) ->
            let _1 = (let data = parseState.GetInput(1) in (Microsoft.FSharp.Core.Operators.unbox data : 'ParseClauseList)) in
            Microsoft.FSharp.Core.Operators.box
                (
                   (
# 27 "pars.fsy"
                      _1 
                   )
# 27 "pars.fsy"
                 : 'ParseProgBody));
# 309 "pars.fs"
        (fun (parseState : Microsoft.FSharp.Text.Parsing.IParseState) ->
            Microsoft.FSharp.Core.Operators.box
                (
                   (
# 29 "pars.fsy"
                      [] 
                   )
# 29 "pars.fsy"
                 : 'ParseClauseList));
# 319 "pars.fs"
        (fun (parseState : Microsoft.FSharp.Text.Parsing.IParseState) ->
            let _1 = (let data = parseState.GetInput(1) in (Microsoft.FSharp.Core.Operators.unbox data : 'ParseClause)) in
            let _2 = (let data = parseState.GetInput(2) in (Microsoft.FSharp.Core.Operators.unbox data : 'ParseClauseList)) in
            Microsoft.FSharp.Core.Operators.box
                (
                   (
# 30 "pars.fsy"
                      _1 :: _2 
                   )
# 30 "pars.fsy"
                 : 'ParseClauseList));
# 331 "pars.fs"
        (fun (parseState : Microsoft.FSharp.Text.Parsing.IParseState) ->
            let _1 = (let data = parseState.GetInput(1) in (Microsoft.FSharp.Core.Operators.unbox data : 'Literal)) in
            Microsoft.FSharp.Core.Operators.box
                (
                   (
# 32 "pars.fsy"
                      PFact(_1)
                   )
# 32 "pars.fsy"
                 : 'ParseClause));
# 342 "pars.fs"
        (fun (parseState : Microsoft.FSharp.Text.Parsing.IParseState) ->
            let _1 = (let data = parseState.GetInput(1) in (Microsoft.FSharp.Core.Operators.unbox data : 'Literal)) in
            Microsoft.FSharp.Core.Operators.box
                (
                   (
# 33 "pars.fsy"
                      PQuery(_1) 
                   )
# 33 "pars.fsy"
                 : 'ParseClause));
# 353 "pars.fs"
        (fun (parseState : Microsoft.FSharp.Text.Parsing.IParseState) ->
            let _1 = (let data = parseState.GetInput(1) in (Microsoft.FSharp.Core.Operators.unbox data : 'Literal)) in
            let _3 = (let data = parseState.GetInput(3) in (Microsoft.FSharp.Core.Operators.unbox data : 'ParseLitList)) in
            Microsoft.FSharp.Core.Operators.box
                (
                   (
# 34 "pars.fsy"
                     PRule(_1, _3)
                   )
# 34 "pars.fsy"
                 : 'ParseClause));
# 365 "pars.fs"
        (fun (parseState : Microsoft.FSharp.Text.Parsing.IParseState) ->
            let _1 = (let data = parseState.GetInput(1) in (Microsoft.FSharp.Core.Operators.unbox data :  Ast.ParseLiteral )) in
            Microsoft.FSharp.Core.Operators.box
                (
                   (
# 36 "pars.fsy"
                      [_1] 
                   )
# 36 "pars.fsy"
                 : 'ParseLitList));
# 376 "pars.fs"
        (fun (parseState : Microsoft.FSharp.Text.Parsing.IParseState) ->
            let _1 = (let data = parseState.GetInput(1) in (Microsoft.FSharp.Core.Operators.unbox data :  Ast.ParseLiteral )) in
            let _3 = (let data = parseState.GetInput(3) in (Microsoft.FSharp.Core.Operators.unbox data : 'ParseLitList)) in
            Microsoft.FSharp.Core.Operators.box
                (
                   (
# 37 "pars.fsy"
                      _1 :: _3 
                   )
# 37 "pars.fsy"
                 : 'ParseLitList));
# 388 "pars.fs"
        (fun (parseState : Microsoft.FSharp.Text.Parsing.IParseState) ->
            let _1 = (let data = parseState.GetInput(1) in (Microsoft.FSharp.Core.Operators.unbox data : 'Predicate)) in
            let _3 = (let data = parseState.GetInput(3) in (Microsoft.FSharp.Core.Operators.unbox data : 'TermList)) in
            Microsoft.FSharp.Core.Operators.box
                (
                   (
# 39 "pars.fsy"
                      PosLiteral(_1, _3) 
                   )
# 39 "pars.fsy"
                 :  Ast.ParseLiteral ));
# 400 "pars.fs"
        (fun (parseState : Microsoft.FSharp.Text.Parsing.IParseState) ->
            let _2 = (let data = parseState.GetInput(2) in (Microsoft.FSharp.Core.Operators.unbox data : 'Predicate)) in
            let _4 = (let data = parseState.GetInput(4) in (Microsoft.FSharp.Core.Operators.unbox data : 'TermList)) in
            Microsoft.FSharp.Core.Operators.box
                (
                   (
# 40 "pars.fsy"
                      NegLiteral(_2, _4) 
                   )
# 40 "pars.fsy"
                 :  Ast.ParseLiteral ));
# 412 "pars.fs"
        (fun (parseState : Microsoft.FSharp.Text.Parsing.IParseState) ->
            let _1 = (let data = parseState.GetInput(1) in (Microsoft.FSharp.Core.Operators.unbox data : 'Filter)) in
            Microsoft.FSharp.Core.Operators.box
                (
                   (
# 41 "pars.fsy"
                      FilterLiteral(_1) 
                   )
# 41 "pars.fsy"
                 :  Ast.ParseLiteral ));
# 423 "pars.fs"
        (fun (parseState : Microsoft.FSharp.Text.Parsing.IParseState) ->
            let _1 = (let data = parseState.GetInput(1) in (Microsoft.FSharp.Core.Operators.unbox data : 'Function)) in
            Microsoft.FSharp.Core.Operators.box
                (
                   (
# 42 "pars.fsy"
                      FunctionLiteral(_1) 
                   )
# 42 "pars.fsy"
                 :  Ast.ParseLiteral ));
# 434 "pars.fs"
        (fun (parseState : Microsoft.FSharp.Text.Parsing.IParseState) ->
            let _1 = (let data = parseState.GetInput(1) in (Microsoft.FSharp.Core.Operators.unbox data : 'Predicate)) in
            let _3 = (let data = parseState.GetInput(3) in (Microsoft.FSharp.Core.Operators.unbox data : 'TermList)) in
            Microsoft.FSharp.Core.Operators.box
                (
                   (
# 44 "pars.fsy"
                      (_1,_3) 
                   )
# 44 "pars.fsy"
                 : 'Literal));
# 446 "pars.fs"
        (fun (parseState : Microsoft.FSharp.Text.Parsing.IParseState) ->
            let _1 = (let data = parseState.GetInput(1) in (Microsoft.FSharp.Core.Operators.unbox data : 'Filter)) in
            Microsoft.FSharp.Core.Operators.box
                (
                   (
# 46 "pars.fsy"
                      [_1] 
                   )
# 46 "pars.fsy"
                 : 'FilterList));
# 457 "pars.fs"
        (fun (parseState : Microsoft.FSharp.Text.Parsing.IParseState) ->
            let _1 = (let data = parseState.GetInput(1) in (Microsoft.FSharp.Core.Operators.unbox data : 'Filter)) in
            let _3 = (let data = parseState.GetInput(3) in (Microsoft.FSharp.Core.Operators.unbox data : 'FilterList)) in
            Microsoft.FSharp.Core.Operators.box
                (
                   (
# 47 "pars.fsy"
                     _1 :: _3
                   )
# 47 "pars.fsy"
                 : 'FilterList));
# 469 "pars.fs"
        (fun (parseState : Microsoft.FSharp.Text.Parsing.IParseState) ->
            let _1 = (let data = parseState.GetInput(1) in (Microsoft.FSharp.Core.Operators.unbox data : 'Term)) in
            let _3 = (let data = parseState.GetInput(3) in (Microsoft.FSharp.Core.Operators.unbox data : 'Term)) in
            Microsoft.FSharp.Core.Operators.box
                (
                   (
# 49 "pars.fsy"
                     LessThan(_1, _3)
                   )
# 49 "pars.fsy"
                 : 'Filter));
# 481 "pars.fs"
        (fun (parseState : Microsoft.FSharp.Text.Parsing.IParseState) ->
            let _1 = (let data = parseState.GetInput(1) in (Microsoft.FSharp.Core.Operators.unbox data : 'Term)) in
            let _3 = (let data = parseState.GetInput(3) in (Microsoft.FSharp.Core.Operators.unbox data : 'Term)) in
            Microsoft.FSharp.Core.Operators.box
                (
                   (
# 50 "pars.fsy"
                     GreaterThan(_1, _3)
                   )
# 50 "pars.fsy"
                 : 'Filter));
# 493 "pars.fs"
        (fun (parseState : Microsoft.FSharp.Text.Parsing.IParseState) ->
            let _1 = (let data = parseState.GetInput(1) in (Microsoft.FSharp.Core.Operators.unbox data : 'Term)) in
            let _4 = (let data = parseState.GetInput(4) in (Microsoft.FSharp.Core.Operators.unbox data : 'Term)) in
            Microsoft.FSharp.Core.Operators.box
                (
                   (
# 51 "pars.fsy"
                     LessThanEqual(_1, _4)
                   )
# 51 "pars.fsy"
                 : 'Filter));
# 505 "pars.fs"
        (fun (parseState : Microsoft.FSharp.Text.Parsing.IParseState) ->
            let _1 = (let data = parseState.GetInput(1) in (Microsoft.FSharp.Core.Operators.unbox data : 'Term)) in
            let _3 = (let data = parseState.GetInput(3) in (Microsoft.FSharp.Core.Operators.unbox data : 'Term)) in
            Microsoft.FSharp.Core.Operators.box
                (
                   (
# 52 "pars.fsy"
                      FilterEqual(_1, _3) 
                   )
# 52 "pars.fsy"
                 : 'Filter));
# 517 "pars.fs"
        (fun (parseState : Microsoft.FSharp.Text.Parsing.IParseState) ->
            let _1 = (let data = parseState.GetInput(1) in (Microsoft.FSharp.Core.Operators.unbox data : 'Function)) in
            Microsoft.FSharp.Core.Operators.box
                (
                   (
# 54 "pars.fsy"
                      [_1] 
                   )
# 54 "pars.fsy"
                 : 'FnList));
# 528 "pars.fs"
        (fun (parseState : Microsoft.FSharp.Text.Parsing.IParseState) ->
            let _1 = (let data = parseState.GetInput(1) in (Microsoft.FSharp.Core.Operators.unbox data : 'Function)) in
            let _3 = (let data = parseState.GetInput(3) in (Microsoft.FSharp.Core.Operators.unbox data : 'FnList)) in
            Microsoft.FSharp.Core.Operators.box
                (
                   (
# 55 "pars.fsy"
                      _1 :: _3 
                   )
# 55 "pars.fsy"
                 : 'FnList));
# 540 "pars.fs"
        (fun (parseState : Microsoft.FSharp.Text.Parsing.IParseState) ->
            let _1 = (let data = parseState.GetInput(1) in (Microsoft.FSharp.Core.Operators.unbox data : 'VarTerm)) in
            let _3 = (let data = parseState.GetInput(3) in (Microsoft.FSharp.Core.Operators.unbox data : 'Expression)) in
            Microsoft.FSharp.Core.Operators.box
                (
                   (
# 57 "pars.fsy"
                      FnEqual(_1, _3) 
                   )
# 57 "pars.fsy"
                 : 'Function));
# 552 "pars.fs"
        (fun (parseState : Microsoft.FSharp.Text.Parsing.IParseState) ->
            Microsoft.FSharp.Core.Operators.box
                (
                   (
# 63 "pars.fsy"
                      [] 
                   )
# 63 "pars.fsy"
                 : 'TermList));
# 562 "pars.fs"
        (fun (parseState : Microsoft.FSharp.Text.Parsing.IParseState) ->
            let _1 = (let data = parseState.GetInput(1) in (Microsoft.FSharp.Core.Operators.unbox data : 'NETermList)) in
            Microsoft.FSharp.Core.Operators.box
                (
                   (
# 64 "pars.fsy"
                     _1
                   )
# 64 "pars.fsy"
                 : 'TermList));
# 573 "pars.fs"
        (fun (parseState : Microsoft.FSharp.Text.Parsing.IParseState) ->
            let _1 = (let data = parseState.GetInput(1) in (Microsoft.FSharp.Core.Operators.unbox data : 'Term)) in
            Microsoft.FSharp.Core.Operators.box
                (
                   (
# 66 "pars.fsy"
                     [_1]
                   )
# 66 "pars.fsy"
                 : 'NETermList));
# 584 "pars.fs"
        (fun (parseState : Microsoft.FSharp.Text.Parsing.IParseState) ->
            let _1 = (let data = parseState.GetInput(1) in (Microsoft.FSharp.Core.Operators.unbox data : 'Term)) in
            let _3 = (let data = parseState.GetInput(3) in (Microsoft.FSharp.Core.Operators.unbox data : 'NETermList)) in
            Microsoft.FSharp.Core.Operators.box
                (
                   (
# 67 "pars.fsy"
                     _1 :: _3
                   )
# 67 "pars.fsy"
                 : 'NETermList));
# 596 "pars.fs"
        (fun (parseState : Microsoft.FSharp.Text.Parsing.IParseState) ->
            let _1 = (let data = parseState.GetInput(1) in (Microsoft.FSharp.Core.Operators.unbox data : 'Term)) in
            Microsoft.FSharp.Core.Operators.box
                (
                   (
# 69 "pars.fsy"
                      Terminal(_1) 
                   )
# 69 "pars.fsy"
                 : 'Expression));
# 607 "pars.fs"
        (fun (parseState : Microsoft.FSharp.Text.Parsing.IParseState) ->
            let _1 = (let data = parseState.GetInput(1) in (Microsoft.FSharp.Core.Operators.unbox data : 'Expression)) in
            let _3 = (let data = parseState.GetInput(3) in (Microsoft.FSharp.Core.Operators.unbox data : 'Expression)) in
            Microsoft.FSharp.Core.Operators.box
                (
                   (
# 70 "pars.fsy"
                      Plus(_1, _3) 
                   )
# 70 "pars.fsy"
                 : 'Expression));
# 619 "pars.fs"
        (fun (parseState : Microsoft.FSharp.Text.Parsing.IParseState) ->
            let _1 = (let data = parseState.GetInput(1) in (Microsoft.FSharp.Core.Operators.unbox data : 'Expression)) in
            let _3 = (let data = parseState.GetInput(3) in (Microsoft.FSharp.Core.Operators.unbox data : 'Expression)) in
            Microsoft.FSharp.Core.Operators.box
                (
                   (
# 71 "pars.fsy"
                      Minus(_1, _3) 
                   )
# 71 "pars.fsy"
                 : 'Expression));
# 631 "pars.fs"
        (fun (parseState : Microsoft.FSharp.Text.Parsing.IParseState) ->
            let _1 = (let data = parseState.GetInput(1) in (Microsoft.FSharp.Core.Operators.unbox data : string)) in
            Microsoft.FSharp.Core.Operators.box
                (
                   (
# 73 "pars.fsy"
                      Var(_1) 
                   )
# 73 "pars.fsy"
                 : 'VarTerm));
# 642 "pars.fs"
        (fun (parseState : Microsoft.FSharp.Text.Parsing.IParseState) ->
            let _1 = (let data = parseState.GetInput(1) in (Microsoft.FSharp.Core.Operators.unbox data : string)) in
            Microsoft.FSharp.Core.Operators.box
                (
                   (
# 75 "pars.fsy"
                      Var(_1) 
                   )
# 75 "pars.fsy"
                 : 'Term));
# 653 "pars.fs"
        (fun (parseState : Microsoft.FSharp.Text.Parsing.IParseState) ->
            let _1 = (let data = parseState.GetInput(1) in (Microsoft.FSharp.Core.Operators.unbox data : int)) in
            Microsoft.FSharp.Core.Operators.box
                (
                   (
# 76 "pars.fsy"
                      Int(_1) 
                   )
# 76 "pars.fsy"
                 : 'Term));
# 664 "pars.fs"
        (fun (parseState : Microsoft.FSharp.Text.Parsing.IParseState) ->
            let _1 = (let data = parseState.GetInput(1) in (Microsoft.FSharp.Core.Operators.unbox data : string)) in
            Microsoft.FSharp.Core.Operators.box
                (
                   (
# 77 "pars.fsy"
                      String(_1) 
                   )
# 77 "pars.fsy"
                 : 'Term));
# 675 "pars.fs"
        (fun (parseState : Microsoft.FSharp.Text.Parsing.IParseState) ->
            let _1 = (let data = parseState.GetInput(1) in (Microsoft.FSharp.Core.Operators.unbox data : string)) in
            Microsoft.FSharp.Core.Operators.box
                (
                   (
# 79 "pars.fsy"
                      Pred(_1) 
                   )
# 79 "pars.fsy"
                 : 'Predicate));
|]
# 687 "pars.fs"
let tables () : Microsoft.FSharp.Text.Parsing.Tables<_> = 
  { reductions= _fsyacc_reductions ();
    endOfInputTag = _fsyacc_endOfInputTag;
    tagOfToken = tagOfToken;
    dataOfToken = _fsyacc_dataOfToken; 
    actionTableElements = _fsyacc_actionTableElements;
    actionTableRowOffsets = _fsyacc_actionTableRowOffsets;
    stateToProdIdxsTableElements = _fsyacc_stateToProdIdxsTableElements;
    stateToProdIdxsTableRowOffsets = _fsyacc_stateToProdIdxsTableRowOffsets;
    reductionSymbolCounts = _fsyacc_reductionSymbolCounts;
    immediateActions = _fsyacc_immediateActions;
    gotos = _fsyacc_gotos;
    sparseGotoTableRowOffsets = _fsyacc_sparseGotoTableRowOffsets;
    tagOfErrorTerminal = _fsyacc_tagOfErrorTerminal;
    parseError = (fun (ctxt:Microsoft.FSharp.Text.Parsing.ParseErrorContext<_>) -> 
                              match parse_error_rich with 
                              | Some f -> f ctxt
                              | None -> parse_error ctxt.Message);
    numTerminals = 24;
    productionToNonTerminalTable = _fsyacc_productionToNonTerminalTable  }
let engine lexer lexbuf startState = (tables ()).Interpret(lexer, lexbuf, startState)
let start lexer lexbuf :  Ast.Prog  =
    Microsoft.FSharp.Core.Operators.unbox ((tables ()).Interpret(lexer, lexbuf, 0))
