// Implementation file for parser generated by fsyacc
#light
#nowarn "64";; // turn off warnings that type variables used in production annotations are instantiated to concrete type
open Microsoft.FSharp.Text.Lexing
open Microsoft.FSharp.Text.Parsing.ParseHelpers
# 1 "pars.fsy"


open Ast


# 12 "pars.fs"
// This type is the type of tokens accepted by the parser
type token = 
  | RPAREN
  | LPAREN
  | COMMA
  | IMPLIES
  | PERIOD
  | TILDE
  | QUERY
  | EOF
  | INCLUDE
  | LANGLE
  | RANGLE
  | NEW
  | NEXT
  | OR
  | AFTER
  | EDB
  | FILENAME of (string)
  | VARSYM of (string)
  | PREDSYM of (string)
// This type is used to give symbolic names to token indexes, useful for error messages
type tokenId = 
    | TOKEN_RPAREN
    | TOKEN_LPAREN
    | TOKEN_COMMA
    | TOKEN_IMPLIES
    | TOKEN_PERIOD
    | TOKEN_TILDE
    | TOKEN_QUERY
    | TOKEN_EOF
    | TOKEN_INCLUDE
    | TOKEN_LANGLE
    | TOKEN_RANGLE
    | TOKEN_NEW
    | TOKEN_NEXT
    | TOKEN_OR
    | TOKEN_AFTER
    | TOKEN_EDB
    | TOKEN_FILENAME
    | TOKEN_VARSYM
    | TOKEN_PREDSYM
    | TOKEN_end_of_input
    | TOKEN_error
// This type is used to give symbolic names to token indexes, useful for error messages
type nonTerminalId = 
    | NONTERM__startstart
    | NONTERM_start
    | NONTERM_Prog
    | NONTERM_Parse_Preprocess
    | NONTERM_Parse_Body
    | NONTERM_Parse_ClauseList
    | NONTERM_Parse_Clause
    | NONTERM_Parse_ZeroaryPredicate
    | NONTERM_Parse_PositiveUnaryPredicateList
    | NONTERM_Parse_PositiveUnaryPredicate
    | NONTERM_Parse_NegativeUnaryPredicate
    | NONTERM_Parse_PositiveLiteral
    | NONTERM_Parse_NegativeLiteral
    | NONTERM_Parse_Literal
    | NONTERM_Parse_UnaryPredicateList
    | NONTERM_Parse_UnaryPredicate
    | NONTERM_Parse_Query
    | NONTERM_Parse_LitList
    | NONTERM_Parse_TermList
    | NONTERM_Parse_Term
    | NONTERM_Parse_Predicate

// This function maps tokens to integers indexes
let tagOfToken (t:token) = 
  match t with
  | RPAREN  -> 0 
  | LPAREN  -> 1 
  | COMMA  -> 2 
  | IMPLIES  -> 3 
  | PERIOD  -> 4 
  | TILDE  -> 5 
  | QUERY  -> 6 
  | EOF  -> 7 
  | INCLUDE  -> 8 
  | LANGLE  -> 9 
  | RANGLE  -> 10 
  | NEW  -> 11 
  | NEXT  -> 12 
  | OR  -> 13 
  | AFTER  -> 14 
  | EDB  -> 15 
  | FILENAME _ -> 16 
  | VARSYM _ -> 17 
  | PREDSYM _ -> 18 

// This function maps integers indexes to symbolic token ids
let tokenTagToTokenId (tokenIdx:int) = 
  match tokenIdx with
  | 0 -> TOKEN_RPAREN 
  | 1 -> TOKEN_LPAREN 
  | 2 -> TOKEN_COMMA 
  | 3 -> TOKEN_IMPLIES 
  | 4 -> TOKEN_PERIOD 
  | 5 -> TOKEN_TILDE 
  | 6 -> TOKEN_QUERY 
  | 7 -> TOKEN_EOF 
  | 8 -> TOKEN_INCLUDE 
  | 9 -> TOKEN_LANGLE 
  | 10 -> TOKEN_RANGLE 
  | 11 -> TOKEN_NEW 
  | 12 -> TOKEN_NEXT 
  | 13 -> TOKEN_OR 
  | 14 -> TOKEN_AFTER 
  | 15 -> TOKEN_EDB 
  | 16 -> TOKEN_FILENAME 
  | 17 -> TOKEN_VARSYM 
  | 18 -> TOKEN_PREDSYM 
  | 21 -> TOKEN_end_of_input
  | 19 -> TOKEN_error
  | _ -> failwith "tokenTagToTokenId: bad token"

/// This function maps production indexes returned in syntax errors to strings representing the non terminal that would be produced by that production
let prodIdxToNonTerminal (prodIdx:int) = 
  match prodIdx with
    | 0 -> NONTERM__startstart 
    | 1 -> NONTERM_start 
    | 2 -> NONTERM_Prog 
    | 3 -> NONTERM_Parse_Preprocess 
    | 4 -> NONTERM_Parse_Preprocess 
    | 5 -> NONTERM_Parse_Body 
    | 6 -> NONTERM_Parse_ClauseList 
    | 7 -> NONTERM_Parse_ClauseList 
    | 8 -> NONTERM_Parse_Clause 
    | 9 -> NONTERM_Parse_Clause 
    | 10 -> NONTERM_Parse_Clause 
    | 11 -> NONTERM_Parse_Clause 
    | 12 -> NONTERM_Parse_Clause 
    | 13 -> NONTERM_Parse_ZeroaryPredicate 
    | 14 -> NONTERM_Parse_PositiveUnaryPredicateList 
    | 15 -> NONTERM_Parse_PositiveUnaryPredicateList 
    | 16 -> NONTERM_Parse_PositiveUnaryPredicateList 
    | 17 -> NONTERM_Parse_PositiveUnaryPredicate 
    | 18 -> NONTERM_Parse_NegativeUnaryPredicate 
    | 19 -> NONTERM_Parse_PositiveLiteral 
    | 20 -> NONTERM_Parse_PositiveLiteral 
    | 21 -> NONTERM_Parse_NegativeLiteral 
    | 22 -> NONTERM_Parse_Literal 
    | 23 -> NONTERM_Parse_Literal 
    | 24 -> NONTERM_Parse_UnaryPredicateList 
    | 25 -> NONTERM_Parse_UnaryPredicateList 
    | 26 -> NONTERM_Parse_UnaryPredicateList 
    | 27 -> NONTERM_Parse_UnaryPredicate 
    | 28 -> NONTERM_Parse_UnaryPredicate 
    | 29 -> NONTERM_Parse_Query 
    | 30 -> NONTERM_Parse_Query 
    | 31 -> NONTERM_Parse_Query 
    | 32 -> NONTERM_Parse_Query 
    | 33 -> NONTERM_Parse_LitList 
    | 34 -> NONTERM_Parse_LitList 
    | 35 -> NONTERM_Parse_TermList 
    | 36 -> NONTERM_Parse_TermList 
    | 37 -> NONTERM_Parse_Term 
    | 38 -> NONTERM_Parse_Predicate 
    | _ -> failwith "prodIdxToNonTerminal: bad production index"

let _fsyacc_endOfInputTag = 21 
let _fsyacc_tagOfErrorTerminal = 19

// This function gets the name of a token as a string
let token_to_string (t:token) = 
  match t with 
  | RPAREN  -> "RPAREN" 
  | LPAREN  -> "LPAREN" 
  | COMMA  -> "COMMA" 
  | IMPLIES  -> "IMPLIES" 
  | PERIOD  -> "PERIOD" 
  | TILDE  -> "TILDE" 
  | QUERY  -> "QUERY" 
  | EOF  -> "EOF" 
  | INCLUDE  -> "INCLUDE" 
  | LANGLE  -> "LANGLE" 
  | RANGLE  -> "RANGLE" 
  | NEW  -> "NEW" 
  | NEXT  -> "NEXT" 
  | OR  -> "OR" 
  | AFTER  -> "AFTER" 
  | EDB  -> "EDB" 
  | FILENAME _ -> "FILENAME" 
  | VARSYM _ -> "VARSYM" 
  | PREDSYM _ -> "PREDSYM" 

// This function gets the data carried by a token as an object
let _fsyacc_dataOfToken (t:token) = 
  match t with 
  | RPAREN  -> (null : System.Object) 
  | LPAREN  -> (null : System.Object) 
  | COMMA  -> (null : System.Object) 
  | IMPLIES  -> (null : System.Object) 
  | PERIOD  -> (null : System.Object) 
  | TILDE  -> (null : System.Object) 
  | QUERY  -> (null : System.Object) 
  | EOF  -> (null : System.Object) 
  | INCLUDE  -> (null : System.Object) 
  | LANGLE  -> (null : System.Object) 
  | RANGLE  -> (null : System.Object) 
  | NEW  -> (null : System.Object) 
  | NEXT  -> (null : System.Object) 
  | OR  -> (null : System.Object) 
  | AFTER  -> (null : System.Object) 
  | EDB  -> (null : System.Object) 
  | FILENAME _fsyacc_x -> Microsoft.FSharp.Core.Operators.box _fsyacc_x 
  | VARSYM _fsyacc_x -> Microsoft.FSharp.Core.Operators.box _fsyacc_x 
  | PREDSYM _fsyacc_x -> Microsoft.FSharp.Core.Operators.box _fsyacc_x 
let _fsyacc_gotos = [| 0us; 65535us; 1us; 65535us; 0us; 1us; 1us; 65535us; 0us; 2us; 2us; 65535us; 0us; 3us; 9us; 10us; 1us; 65535us; 3us; 4us; 2us; 65535us; 3us; 11us; 12us; 13us; 2us; 65535us; 3us; 12us; 12us; 12us; 10us; 65535us; 3us; 48us; 12us; 48us; 14us; 48us; 21us; 48us; 26us; 27us; 31us; 48us; 65us; 48us; 70us; 48us; 71us; 48us; 73us; 48us; 2us; 65535us; 24us; 25us; 37us; 38us; 5us; 65535us; 17us; 18us; 24us; 36us; 29us; 62us; 37us; 36us; 60us; 62us; 2us; 65535us; 29us; 63us; 60us; 63us; 9us; 65535us; 3us; 20us; 12us; 20us; 14us; 64us; 21us; 57us; 31us; 57us; 65us; 64us; 70us; 64us; 71us; 64us; 73us; 57us; 3us; 65535us; 21us; 58us; 31us; 58us; 73us; 58us; 3us; 65535us; 21us; 72us; 31us; 72us; 73us; 72us; 2us; 65535us; 29us; 30us; 60us; 61us; 2us; 65535us; 29us; 59us; 60us; 59us; 4us; 65535us; 14us; 15us; 65us; 66us; 70us; 68us; 71us; 69us; 3us; 65535us; 21us; 22us; 31us; 32us; 73us; 74us; 3us; 65535us; 49us; 50us; 54us; 55us; 76us; 77us; 5us; 65535us; 40us; 41us; 45us; 46us; 49us; 75us; 54us; 75us; 76us; 75us; 17us; 65535us; 3us; 35us; 12us; 35us; 14us; 35us; 17us; 39us; 21us; 35us; 24us; 39us; 26us; 34us; 29us; 39us; 31us; 35us; 37us; 39us; 43us; 44us; 52us; 53us; 60us; 39us; 65us; 35us; 70us; 35us; 71us; 35us; 73us; 35us; |]
let _fsyacc_sparseGotoTableRowOffsets = [|0us; 1us; 3us; 5us; 8us; 10us; 13us; 16us; 27us; 30us; 36us; 39us; 49us; 53us; 57us; 60us; 63us; 68us; 72us; 76us; 82us; |]
let _fsyacc_stateToProdIdxsTableElements = [| 1us; 0us; 1us; 0us; 1us; 1us; 1us; 2us; 1us; 2us; 1us; 2us; 1us; 4us; 1us; 4us; 1us; 4us; 1us; 4us; 1us; 4us; 1us; 5us; 1us; 7us; 1us; 7us; 1us; 8us; 3us; 8us; 31us; 32us; 1us; 8us; 1us; 9us; 1us; 9us; 1us; 9us; 1us; 10us; 1us; 10us; 1us; 10us; 1us; 10us; 1us; 11us; 1us; 11us; 1us; 11us; 1us; 11us; 1us; 11us; 1us; 12us; 1us; 12us; 1us; 12us; 1us; 12us; 1us; 12us; 1us; 13us; 2us; 13us; 20us; 2us; 15us; 16us; 1us; 16us; 1us; 16us; 1us; 17us; 1us; 17us; 1us; 17us; 1us; 17us; 1us; 18us; 1us; 18us; 1us; 18us; 1us; 18us; 1us; 18us; 1us; 19us; 1us; 20us; 1us; 20us; 1us; 20us; 1us; 21us; 1us; 21us; 1us; 21us; 1us; 21us; 1us; 21us; 1us; 22us; 1us; 23us; 2us; 25us; 26us; 1us; 26us; 1us; 26us; 1us; 27us; 1us; 28us; 1us; 29us; 1us; 30us; 3us; 30us; 31us; 32us; 1us; 30us; 3us; 31us; 31us; 32us; 3us; 31us; 32us; 32us; 1us; 31us; 1us; 32us; 2us; 33us; 34us; 1us; 34us; 1us; 34us; 2us; 35us; 36us; 1us; 36us; 1us; 36us; 1us; 37us; 1us; 38us; |]
let _fsyacc_stateToProdIdxsTableRowOffsets = [|0us; 2us; 4us; 6us; 8us; 10us; 12us; 14us; 16us; 18us; 20us; 22us; 24us; 26us; 28us; 30us; 34us; 36us; 38us; 40us; 42us; 44us; 46us; 48us; 50us; 52us; 54us; 56us; 58us; 60us; 62us; 64us; 66us; 68us; 70us; 72us; 75us; 78us; 80us; 82us; 84us; 86us; 88us; 90us; 92us; 94us; 96us; 98us; 100us; 102us; 104us; 106us; 108us; 110us; 112us; 114us; 116us; 118us; 120us; 122us; 125us; 127us; 129us; 131us; 133us; 135us; 137us; 141us; 143us; 147us; 151us; 153us; 155us; 158us; 160us; 162us; 165us; 167us; 169us; 171us; |]
let _fsyacc_action_rows = 80
let _fsyacc_actionTableElements = [|1us; 16387us; 8us; 6us; 0us; 49152us; 0us; 16385us; 5us; 16390us; 6us; 14us; 11us; 24us; 12us; 29us; 15us; 17us; 18us; 79us; 1us; 32768us; 7us; 5us; 0us; 16386us; 1us; 32768us; 9us; 7us; 1us; 32768us; 16us; 8us; 1us; 32768us; 10us; 9us; 1us; 16387us; 8us; 6us; 0us; 16388us; 0us; 16389us; 5us; 16390us; 6us; 14us; 11us; 24us; 12us; 29us; 15us; 17us; 18us; 79us; 0us; 16391us; 2us; 32768us; 1us; 65us; 18us; 79us; 3us; 32768us; 4us; 16us; 13us; 70us; 14us; 71us; 0us; 16392us; 1us; 32768us; 18us; 79us; 1us; 32768us; 4us; 19us; 0us; 16393us; 1us; 32768us; 3us; 21us; 2us; 32768us; 5us; 52us; 18us; 79us; 1us; 32768us; 4us; 23us; 0us; 16394us; 1us; 16398us; 18us; 79us; 1us; 32768us; 3us; 26us; 1us; 32768us; 18us; 79us; 1us; 32768us; 4us; 28us; 0us; 16395us; 2us; 16408us; 5us; 43us; 18us; 79us; 1us; 32768us; 3us; 31us; 2us; 32768us; 5us; 52us; 18us; 79us; 1us; 32768us; 4us; 33us; 0us; 16396us; 0us; 16397us; 1us; 16397us; 1us; 49us; 1us; 16399us; 2us; 37us; 1us; 16398us; 18us; 79us; 0us; 16400us; 1us; 32768us; 1us; 40us; 1us; 32768us; 17us; 78us; 1us; 32768us; 0us; 42us; 0us; 16401us; 1us; 32768us; 18us; 79us; 1us; 32768us; 1us; 45us; 1us; 32768us; 17us; 78us; 1us; 32768us; 0us; 47us; 0us; 16402us; 0us; 16403us; 1us; 32768us; 17us; 78us; 1us; 32768us; 0us; 51us; 0us; 16404us; 1us; 32768us; 18us; 79us; 1us; 32768us; 1us; 54us; 1us; 32768us; 17us; 78us; 1us; 32768us; 0us; 56us; 0us; 16405us; 0us; 16406us; 0us; 16407us; 1us; 16409us; 2us; 60us; 2us; 16408us; 5us; 43us; 18us; 79us; 0us; 16410us; 0us; 16411us; 0us; 16412us; 0us; 16413us; 2us; 32768us; 1us; 65us; 18us; 79us; 3us; 32768us; 0us; 67us; 13us; 70us; 14us; 71us; 0us; 16414us; 1us; 16415us; 14us; 71us; 0us; 16416us; 2us; 32768us; 1us; 65us; 18us; 79us; 2us; 32768us; 1us; 65us; 18us; 79us; 1us; 16417us; 2us; 73us; 2us; 32768us; 5us; 52us; 18us; 79us; 0us; 16418us; 1us; 16419us; 2us; 76us; 1us; 32768us; 17us; 78us; 0us; 16420us; 0us; 16421us; 0us; 16422us; |]
let _fsyacc_actionTableRowOffsets = [|0us; 2us; 3us; 4us; 10us; 12us; 13us; 15us; 17us; 19us; 21us; 22us; 23us; 29us; 30us; 33us; 37us; 38us; 40us; 42us; 43us; 45us; 48us; 50us; 51us; 53us; 55us; 57us; 59us; 60us; 63us; 65us; 68us; 70us; 71us; 72us; 74us; 76us; 78us; 79us; 81us; 83us; 85us; 86us; 88us; 90us; 92us; 94us; 95us; 96us; 98us; 100us; 101us; 103us; 105us; 107us; 109us; 110us; 111us; 112us; 114us; 117us; 118us; 119us; 120us; 121us; 124us; 128us; 129us; 131us; 132us; 135us; 138us; 140us; 143us; 144us; 146us; 148us; 149us; 150us; |]
let _fsyacc_reductionSymbolCounts = [|1us; 1us; 3us; 0us; 5us; 1us; 0us; 2us; 3us; 3us; 4us; 5us; 5us; 1us; 0us; 1us; 3us; 4us; 5us; 1us; 4us; 5us; 1us; 1us; 0us; 1us; 3us; 1us; 1us; 1us; 3us; 3us; 3us; 1us; 3us; 1us; 3us; 1us; 1us; |]
let _fsyacc_productionToNonTerminalTable = [|0us; 1us; 2us; 3us; 3us; 4us; 5us; 5us; 6us; 6us; 6us; 6us; 6us; 7us; 8us; 8us; 8us; 9us; 10us; 11us; 11us; 12us; 13us; 13us; 14us; 14us; 14us; 15us; 15us; 16us; 16us; 16us; 16us; 17us; 17us; 18us; 18us; 19us; 20us; |]
let _fsyacc_immediateActions = [|65535us; 49152us; 16385us; 65535us; 65535us; 16386us; 65535us; 65535us; 65535us; 65535us; 16388us; 16389us; 65535us; 16391us; 65535us; 65535us; 16392us; 65535us; 65535us; 16393us; 65535us; 65535us; 65535us; 16394us; 65535us; 65535us; 65535us; 65535us; 16395us; 65535us; 65535us; 65535us; 65535us; 16396us; 16397us; 65535us; 65535us; 65535us; 16400us; 65535us; 65535us; 65535us; 16401us; 65535us; 65535us; 65535us; 65535us; 16402us; 16403us; 65535us; 65535us; 16404us; 65535us; 65535us; 65535us; 65535us; 16405us; 16406us; 16407us; 65535us; 65535us; 16410us; 16411us; 16412us; 16413us; 65535us; 65535us; 16414us; 65535us; 65535us; 65535us; 65535us; 65535us; 65535us; 16418us; 65535us; 65535us; 16420us; 16421us; 16422us; |]
let _fsyacc_reductions ()  =    [| 
# 233 "pars.fs"
        (fun (parseState : Microsoft.FSharp.Text.Parsing.IParseState) ->
            let _1 = (let data = parseState.GetInput(1) in (Microsoft.FSharp.Core.Operators.unbox data :  Ast.Prog )) in
            Microsoft.FSharp.Core.Operators.box
                (
                   (
                      raise (Microsoft.FSharp.Text.Parsing.Accept(Microsoft.FSharp.Core.Operators.box _1))
                   )
                 : '_startstart));
# 242 "pars.fs"
        (fun (parseState : Microsoft.FSharp.Text.Parsing.IParseState) ->
            let _1 = (let data = parseState.GetInput(1) in (Microsoft.FSharp.Core.Operators.unbox data : 'Prog)) in
            Microsoft.FSharp.Core.Operators.box
                (
                   (
# 19 "pars.fsy"
                      _1 
                   )
# 19 "pars.fsy"
                 :  Ast.Prog ));
# 253 "pars.fs"
        (fun (parseState : Microsoft.FSharp.Text.Parsing.IParseState) ->
            let _1 = (let data = parseState.GetInput(1) in (Microsoft.FSharp.Core.Operators.unbox data : 'Parse_Preprocess)) in
            let _2 = (let data = parseState.GetInput(2) in (Microsoft.FSharp.Core.Operators.unbox data : 'Parse_Body)) in
            Microsoft.FSharp.Core.Operators.box
                (
                   (
# 21 "pars.fsy"
                      PProg(Filenames(_1), _2 ) 
                   )
# 21 "pars.fsy"
                 : 'Prog));
# 265 "pars.fs"
        (fun (parseState : Microsoft.FSharp.Text.Parsing.IParseState) ->
            Microsoft.FSharp.Core.Operators.box
                (
                   (
# 23 "pars.fsy"
                      [] 
                   )
# 23 "pars.fsy"
                 : 'Parse_Preprocess));
# 275 "pars.fs"
        (fun (parseState : Microsoft.FSharp.Text.Parsing.IParseState) ->
            let _3 = (let data = parseState.GetInput(3) in (Microsoft.FSharp.Core.Operators.unbox data : string)) in
            let _5 = (let data = parseState.GetInput(5) in (Microsoft.FSharp.Core.Operators.unbox data : 'Parse_Preprocess)) in
            Microsoft.FSharp.Core.Operators.box
                (
                   (
# 24 "pars.fsy"
                      _3 :: _5 
                   )
# 24 "pars.fsy"
                 : 'Parse_Preprocess));
# 287 "pars.fs"
        (fun (parseState : Microsoft.FSharp.Text.Parsing.IParseState) ->
            let _1 = (let data = parseState.GetInput(1) in (Microsoft.FSharp.Core.Operators.unbox data : 'Parse_ClauseList)) in
            Microsoft.FSharp.Core.Operators.box
                (
                   (
# 26 "pars.fsy"
                      _1 
                   )
# 26 "pars.fsy"
                 : 'Parse_Body));
# 298 "pars.fs"
        (fun (parseState : Microsoft.FSharp.Text.Parsing.IParseState) ->
            Microsoft.FSharp.Core.Operators.box
                (
                   (
# 28 "pars.fsy"
                      [] 
                   )
# 28 "pars.fsy"
                 : 'Parse_ClauseList));
# 308 "pars.fs"
        (fun (parseState : Microsoft.FSharp.Text.Parsing.IParseState) ->
            let _1 = (let data = parseState.GetInput(1) in (Microsoft.FSharp.Core.Operators.unbox data : 'Parse_Clause)) in
            let _2 = (let data = parseState.GetInput(2) in (Microsoft.FSharp.Core.Operators.unbox data : 'Parse_ClauseList)) in
            Microsoft.FSharp.Core.Operators.box
                (
                   (
# 29 "pars.fsy"
                      _1 :: _2 
                   )
# 29 "pars.fsy"
                 : 'Parse_ClauseList));
# 320 "pars.fs"
        (fun (parseState : Microsoft.FSharp.Text.Parsing.IParseState) ->
            let _2 = (let data = parseState.GetInput(2) in (Microsoft.FSharp.Core.Operators.unbox data : 'Parse_Query)) in
            Microsoft.FSharp.Core.Operators.box
                (
                   (
# 32 "pars.fsy"
                      PQuery(_2) 
                   )
# 32 "pars.fsy"
                 : 'Parse_Clause));
# 331 "pars.fs"
        (fun (parseState : Microsoft.FSharp.Text.Parsing.IParseState) ->
            let _2 = (let data = parseState.GetInput(2) in (Microsoft.FSharp.Core.Operators.unbox data : 'Parse_PositiveUnaryPredicate)) in
            Microsoft.FSharp.Core.Operators.box
                (
                   (
# 33 "pars.fsy"
                      PEdb(_2)
                   )
# 33 "pars.fsy"
                 : 'Parse_Clause));
# 342 "pars.fs"
        (fun (parseState : Microsoft.FSharp.Text.Parsing.IParseState) ->
            let _1 = (let data = parseState.GetInput(1) in (Microsoft.FSharp.Core.Operators.unbox data : 'Parse_PositiveLiteral)) in
            let _3 = (let data = parseState.GetInput(3) in (Microsoft.FSharp.Core.Operators.unbox data : 'Parse_LitList)) in
            Microsoft.FSharp.Core.Operators.box
                (
                   (
# 34 "pars.fsy"
                     PRule(_1, _3)
                   )
# 34 "pars.fsy"
                 : 'Parse_Clause));
# 354 "pars.fs"
        (fun (parseState : Microsoft.FSharp.Text.Parsing.IParseState) ->
            let _2 = (let data = parseState.GetInput(2) in (Microsoft.FSharp.Core.Operators.unbox data : 'Parse_PositiveUnaryPredicateList)) in
            let _4 = (let data = parseState.GetInput(4) in (Microsoft.FSharp.Core.Operators.unbox data : 'Parse_ZeroaryPredicate)) in
            Microsoft.FSharp.Core.Operators.box
                (
                   (
# 35 "pars.fsy"
                      PNewRule(_2,_4) 
                   )
# 35 "pars.fsy"
                 : 'Parse_Clause));
# 366 "pars.fs"
        (fun (parseState : Microsoft.FSharp.Text.Parsing.IParseState) ->
            let _2 = (let data = parseState.GetInput(2) in (Microsoft.FSharp.Core.Operators.unbox data : 'Parse_UnaryPredicateList)) in
            let _4 = (let data = parseState.GetInput(4) in (Microsoft.FSharp.Core.Operators.unbox data : 'Parse_LitList)) in
            Microsoft.FSharp.Core.Operators.box
                (
                   (
# 36 "pars.fsy"
                      PNextRule(_2, _4) 
                   )
# 36 "pars.fsy"
                 : 'Parse_Clause));
# 378 "pars.fs"
        (fun (parseState : Microsoft.FSharp.Text.Parsing.IParseState) ->
            let _1 = (let data = parseState.GetInput(1) in (Microsoft.FSharp.Core.Operators.unbox data : 'Parse_Predicate)) in
            Microsoft.FSharp.Core.Operators.box
                (
                   (
# 39 "pars.fsy"
                      (_1) 
                   )
# 39 "pars.fsy"
                 : 'Parse_ZeroaryPredicate));
# 389 "pars.fs"
        (fun (parseState : Microsoft.FSharp.Text.Parsing.IParseState) ->
            Microsoft.FSharp.Core.Operators.box
                (
                   (
# 42 "pars.fsy"
                      [] 
                   )
# 42 "pars.fsy"
                 : 'Parse_PositiveUnaryPredicateList));
# 399 "pars.fs"
        (fun (parseState : Microsoft.FSharp.Text.Parsing.IParseState) ->
            let _1 = (let data = parseState.GetInput(1) in (Microsoft.FSharp.Core.Operators.unbox data : 'Parse_PositiveUnaryPredicate)) in
            Microsoft.FSharp.Core.Operators.box
                (
                   (
# 43 "pars.fsy"
                      _1 :: [] 
                   )
# 43 "pars.fsy"
                 : 'Parse_PositiveUnaryPredicateList));
# 410 "pars.fs"
        (fun (parseState : Microsoft.FSharp.Text.Parsing.IParseState) ->
            let _1 = (let data = parseState.GetInput(1) in (Microsoft.FSharp.Core.Operators.unbox data : 'Parse_PositiveUnaryPredicate)) in
            let _3 = (let data = parseState.GetInput(3) in (Microsoft.FSharp.Core.Operators.unbox data : 'Parse_PositiveUnaryPredicateList)) in
            Microsoft.FSharp.Core.Operators.box
                (
                   (
# 44 "pars.fsy"
                      _1 :: _3 
                   )
# 44 "pars.fsy"
                 : 'Parse_PositiveUnaryPredicateList));
# 422 "pars.fs"
        (fun (parseState : Microsoft.FSharp.Text.Parsing.IParseState) ->
            let _1 = (let data = parseState.GetInput(1) in (Microsoft.FSharp.Core.Operators.unbox data : 'Parse_Predicate)) in
            let _3 = (let data = parseState.GetInput(3) in (Microsoft.FSharp.Core.Operators.unbox data : 'Parse_Term)) in
            Microsoft.FSharp.Core.Operators.box
                (
                   (
# 47 "pars.fsy"
                      PosUp(BaseUnary(_1,_3) ) 
                   )
# 47 "pars.fsy"
                 : 'Parse_PositiveUnaryPredicate));
# 434 "pars.fs"
        (fun (parseState : Microsoft.FSharp.Text.Parsing.IParseState) ->
            let _2 = (let data = parseState.GetInput(2) in (Microsoft.FSharp.Core.Operators.unbox data : 'Parse_Predicate)) in
            let _4 = (let data = parseState.GetInput(4) in (Microsoft.FSharp.Core.Operators.unbox data : 'Parse_Term)) in
            Microsoft.FSharp.Core.Operators.box
                (
                   (
# 49 "pars.fsy"
                      NegUp (BaseUnary(_2,_4)) 
                   )
# 49 "pars.fsy"
                 : 'Parse_NegativeUnaryPredicate));
# 446 "pars.fs"
        (fun (parseState : Microsoft.FSharp.Text.Parsing.IParseState) ->
            let _1 = (let data = parseState.GetInput(1) in (Microsoft.FSharp.Core.Operators.unbox data : 'Parse_ZeroaryPredicate)) in
            Microsoft.FSharp.Core.Operators.box
                (
                   (
# 52 "pars.fsy"
                      match _1 with x -> PosLit( Base(x,[]) ) 
                   )
# 52 "pars.fsy"
                 : 'Parse_PositiveLiteral));
# 457 "pars.fs"
        (fun (parseState : Microsoft.FSharp.Text.Parsing.IParseState) ->
            let _1 = (let data = parseState.GetInput(1) in (Microsoft.FSharp.Core.Operators.unbox data : 'Parse_Predicate)) in
            let _3 = (let data = parseState.GetInput(3) in (Microsoft.FSharp.Core.Operators.unbox data : 'Parse_TermList)) in
            Microsoft.FSharp.Core.Operators.box
                (
                   (
# 53 "pars.fsy"
                      PosLit(Base(_1,_3) ) 
                   )
# 53 "pars.fsy"
                 : 'Parse_PositiveLiteral));
# 469 "pars.fs"
        (fun (parseState : Microsoft.FSharp.Text.Parsing.IParseState) ->
            let _2 = (let data = parseState.GetInput(2) in (Microsoft.FSharp.Core.Operators.unbox data : 'Parse_Predicate)) in
            let _4 = (let data = parseState.GetInput(4) in (Microsoft.FSharp.Core.Operators.unbox data : 'Parse_TermList)) in
            Microsoft.FSharp.Core.Operators.box
                (
                   (
# 56 "pars.fsy"
                      NegLit(Base(_2,_4) ) 
                   )
# 56 "pars.fsy"
                 : 'Parse_NegativeLiteral));
# 481 "pars.fs"
        (fun (parseState : Microsoft.FSharp.Text.Parsing.IParseState) ->
            let _1 = (let data = parseState.GetInput(1) in (Microsoft.FSharp.Core.Operators.unbox data : 'Parse_PositiveLiteral)) in
            Microsoft.FSharp.Core.Operators.box
                (
                   (
# 60 "pars.fsy"
                      PosLiteral(_1) 
                   )
# 60 "pars.fsy"
                 : 'Parse_Literal));
# 492 "pars.fs"
        (fun (parseState : Microsoft.FSharp.Text.Parsing.IParseState) ->
            let _1 = (let data = parseState.GetInput(1) in (Microsoft.FSharp.Core.Operators.unbox data : 'Parse_NegativeLiteral)) in
            Microsoft.FSharp.Core.Operators.box
                (
                   (
# 61 "pars.fsy"
                      NegLiteral(_1) 
                   )
# 61 "pars.fsy"
                 : 'Parse_Literal));
# 503 "pars.fs"
        (fun (parseState : Microsoft.FSharp.Text.Parsing.IParseState) ->
            Microsoft.FSharp.Core.Operators.box
                (
                   (
# 64 "pars.fsy"
                      [] 
                   )
# 64 "pars.fsy"
                 : 'Parse_UnaryPredicateList));
# 513 "pars.fs"
        (fun (parseState : Microsoft.FSharp.Text.Parsing.IParseState) ->
            let _1 = (let data = parseState.GetInput(1) in (Microsoft.FSharp.Core.Operators.unbox data : 'Parse_UnaryPredicate)) in
            Microsoft.FSharp.Core.Operators.box
                (
                   (
# 65 "pars.fsy"
                      _1 :: [] 
                   )
# 65 "pars.fsy"
                 : 'Parse_UnaryPredicateList));
# 524 "pars.fs"
        (fun (parseState : Microsoft.FSharp.Text.Parsing.IParseState) ->
            let _1 = (let data = parseState.GetInput(1) in (Microsoft.FSharp.Core.Operators.unbox data : 'Parse_UnaryPredicate)) in
            let _3 = (let data = parseState.GetInput(3) in (Microsoft.FSharp.Core.Operators.unbox data : 'Parse_UnaryPredicateList)) in
            Microsoft.FSharp.Core.Operators.box
                (
                   (
# 66 "pars.fsy"
                      _1 :: _3 
                   )
# 66 "pars.fsy"
                 : 'Parse_UnaryPredicateList));
# 536 "pars.fs"
        (fun (parseState : Microsoft.FSharp.Text.Parsing.IParseState) ->
            let _1 = (let data = parseState.GetInput(1) in (Microsoft.FSharp.Core.Operators.unbox data : 'Parse_PositiveUnaryPredicate)) in
            Microsoft.FSharp.Core.Operators.box
                (
                   (
# 68 "pars.fsy"
                      PUP(_1) 
                   )
# 68 "pars.fsy"
                 : 'Parse_UnaryPredicate));
# 547 "pars.fs"
        (fun (parseState : Microsoft.FSharp.Text.Parsing.IParseState) ->
            let _1 = (let data = parseState.GetInput(1) in (Microsoft.FSharp.Core.Operators.unbox data : 'Parse_NegativeUnaryPredicate)) in
            Microsoft.FSharp.Core.Operators.box
                (
                   (
# 69 "pars.fsy"
                      NUP(_1) 
                   )
# 69 "pars.fsy"
                 : 'Parse_UnaryPredicate));
# 558 "pars.fs"
        (fun (parseState : Microsoft.FSharp.Text.Parsing.IParseState) ->
            let _1 = (let data = parseState.GetInput(1) in (Microsoft.FSharp.Core.Operators.unbox data : 'Parse_PositiveLiteral)) in
            Microsoft.FSharp.Core.Operators.box
                (
                   (
# 72 "pars.fsy"
                      BaseQuery(_1) 
                   )
# 72 "pars.fsy"
                 : 'Parse_Query));
# 569 "pars.fs"
        (fun (parseState : Microsoft.FSharp.Text.Parsing.IParseState) ->
            let _2 = (let data = parseState.GetInput(2) in (Microsoft.FSharp.Core.Operators.unbox data : 'Parse_Query)) in
            Microsoft.FSharp.Core.Operators.box
                (
                   (
# 73 "pars.fsy"
                      _2 
                   )
# 73 "pars.fsy"
                 : 'Parse_Query));
# 580 "pars.fs"
        (fun (parseState : Microsoft.FSharp.Text.Parsing.IParseState) ->
            let _1 = (let data = parseState.GetInput(1) in (Microsoft.FSharp.Core.Operators.unbox data : 'Parse_Query)) in
            let _3 = (let data = parseState.GetInput(3) in (Microsoft.FSharp.Core.Operators.unbox data : 'Parse_Query)) in
            Microsoft.FSharp.Core.Operators.box
                (
                   (
# 74 "pars.fsy"
                      ORQuery(_1,_3) 
                   )
# 74 "pars.fsy"
                 : 'Parse_Query));
# 592 "pars.fs"
        (fun (parseState : Microsoft.FSharp.Text.Parsing.IParseState) ->
            let _1 = (let data = parseState.GetInput(1) in (Microsoft.FSharp.Core.Operators.unbox data : 'Parse_Query)) in
            let _3 = (let data = parseState.GetInput(3) in (Microsoft.FSharp.Core.Operators.unbox data : 'Parse_Query)) in
            Microsoft.FSharp.Core.Operators.box
                (
                   (
# 75 "pars.fsy"
                      AfterQuery(_1,_3) 
                   )
# 75 "pars.fsy"
                 : 'Parse_Query));
# 604 "pars.fs"
        (fun (parseState : Microsoft.FSharp.Text.Parsing.IParseState) ->
            let _1 = (let data = parseState.GetInput(1) in (Microsoft.FSharp.Core.Operators.unbox data : 'Parse_Literal)) in
            Microsoft.FSharp.Core.Operators.box
                (
                   (
# 78 "pars.fsy"
                      [_1] 
                   )
# 78 "pars.fsy"
                 : 'Parse_LitList));
# 615 "pars.fs"
        (fun (parseState : Microsoft.FSharp.Text.Parsing.IParseState) ->
            let _1 = (let data = parseState.GetInput(1) in (Microsoft.FSharp.Core.Operators.unbox data : 'Parse_Literal)) in
            let _3 = (let data = parseState.GetInput(3) in (Microsoft.FSharp.Core.Operators.unbox data : 'Parse_LitList)) in
            Microsoft.FSharp.Core.Operators.box
                (
                   (
# 79 "pars.fsy"
                      _1 :: _3 
                   )
# 79 "pars.fsy"
                 : 'Parse_LitList));
# 627 "pars.fs"
        (fun (parseState : Microsoft.FSharp.Text.Parsing.IParseState) ->
            let _1 = (let data = parseState.GetInput(1) in (Microsoft.FSharp.Core.Operators.unbox data : 'Parse_Term)) in
            Microsoft.FSharp.Core.Operators.box
                (
                   (
# 81 "pars.fsy"
                     [_1]
                   )
# 81 "pars.fsy"
                 : 'Parse_TermList));
# 638 "pars.fs"
        (fun (parseState : Microsoft.FSharp.Text.Parsing.IParseState) ->
            let _1 = (let data = parseState.GetInput(1) in (Microsoft.FSharp.Core.Operators.unbox data : 'Parse_Term)) in
            let _3 = (let data = parseState.GetInput(3) in (Microsoft.FSharp.Core.Operators.unbox data : 'Parse_TermList)) in
            Microsoft.FSharp.Core.Operators.box
                (
                   (
# 82 "pars.fsy"
                     _1 :: _3
                   )
# 82 "pars.fsy"
                 : 'Parse_TermList));
# 650 "pars.fs"
        (fun (parseState : Microsoft.FSharp.Text.Parsing.IParseState) ->
            let _1 = (let data = parseState.GetInput(1) in (Microsoft.FSharp.Core.Operators.unbox data : string)) in
            Microsoft.FSharp.Core.Operators.box
                (
                   (
# 84 "pars.fsy"
                      Var(_1) 
                   )
# 84 "pars.fsy"
                 : 'Parse_Term));
# 661 "pars.fs"
        (fun (parseState : Microsoft.FSharp.Text.Parsing.IParseState) ->
            let _1 = (let data = parseState.GetInput(1) in (Microsoft.FSharp.Core.Operators.unbox data : string)) in
            Microsoft.FSharp.Core.Operators.box
                (
                   (
# 86 "pars.fsy"
                      Pred(_1) 
                   )
# 86 "pars.fsy"
                 : 'Parse_Predicate));
|]
# 673 "pars.fs"
let tables () : Microsoft.FSharp.Text.Parsing.Tables<_> = 
  { reductions= _fsyacc_reductions ();
    endOfInputTag = _fsyacc_endOfInputTag;
    tagOfToken = tagOfToken;
    dataOfToken = _fsyacc_dataOfToken; 
    actionTableElements = _fsyacc_actionTableElements;
    actionTableRowOffsets = _fsyacc_actionTableRowOffsets;
    stateToProdIdxsTableElements = _fsyacc_stateToProdIdxsTableElements;
    stateToProdIdxsTableRowOffsets = _fsyacc_stateToProdIdxsTableRowOffsets;
    reductionSymbolCounts = _fsyacc_reductionSymbolCounts;
    immediateActions = _fsyacc_immediateActions;
    gotos = _fsyacc_gotos;
    sparseGotoTableRowOffsets = _fsyacc_sparseGotoTableRowOffsets;
    tagOfErrorTerminal = _fsyacc_tagOfErrorTerminal;
    parseError = (fun (ctxt:Microsoft.FSharp.Text.Parsing.ParseErrorContext<_>) -> 
                              match parse_error_rich with 
                              | Some f -> f ctxt
                              | None -> parse_error ctxt.Message);
    numTerminals = 22;
    productionToNonTerminalTable = _fsyacc_productionToNonTerminalTable  }
let engine lexer lexbuf startState = (tables ()).Interpret(lexer, lexbuf, startState)
let start lexer lexbuf :  Ast.Prog  =
    Microsoft.FSharp.Core.Operators.unbox ((tables ()).Interpret(lexer, lexbuf, 0))
